#!/usr/bin/env node
import { execSync as l } from "node:child_process";
import g, { resolve as F } from "node:path";
import u, { existsSync as v, rmSync as f } from "node:fs";
import { log as r, xPrompts as c, lookForParentTarget as G, createMainCommand as D, createSubcommand as M } from "@done-coding/cli-utils";
import { getConfigPath as R, batchCompileHandler as A, MODULE_DEFAULT_CONFIG_RELATIVE_PATH as L } from "@done-coding/cli-template";
import { getTargetRepoUrl as O } from "@done-coding/cli-git";
const y = {
  name: "create-done-coding",
  version: "0.10.3",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
}, w = "git@gitee.com:justsosu/done-coding-cli-config-json.git", C = "自定义模版路径", j = "某个git平台用户仓库", S = `./.${y.name}_temp`;
let $;
const I = async () => ($ || ($ = (await Y()).templateList), $), E = async () => [
  ...await I(),
  { name: C },
  { name: j }
], b = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "项目名称不能为空"
}, U = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await E()).map((t) => {
    var n;
    return {
      title: t.branch ? `${t.name}(${t.branch})` : t.name,
      value: t.name,
      description: `${t.description || ""}${(n = t.instances) != null && n.length ? `, 已应用于: ${[""].concat(t.instances).join(`
- `)}` : ""}` || void 0
    };
  }),
  validate: (t) => t.trim().length > 0 || "模板不能为空"
}), H = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, x = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), k = {
  type: "text",
  name: "customUrl",
  message: "请输入自定义模板路径",
  validate: (e) => e.trim().length > 0 || "路径不能为空"
}, B = (e) => ({
  type: "text",
  name: "gitCommitMessage",
  message: "请输入git提交信息",
  initial: `feat: 初始化项目${e}`,
  validate: (t) => t.trim().length > 0 || "提交信息不能为空"
}), Y = async () => {
  r.stage("拉取模板列表，请稍等...");
  const e = g.resolve(
    process.cwd(),
    S
  );
  if (v(e))
    return r.error(`${e} 已存在，请手动删除该目录再试`), process.exit(1);
  if (r.info(`配置临时目录：${e}`), u.existsSync(e)) {
    const n = `${e}目录已存在，是否删除？`, { isRemove: o } = await c(x(n));
    if (o)
      u.rmSync(e, { recursive: !0, force: !0 });
    else
      return r.error(`${e} 已存在，请手动删除该目录再试`), process.exit(1);
  }
  let t;
  try {
    l(`git clone ${w} ${e} --depth=1`);
    const n = y.name, o = g.resolve(e, `${n}.json`);
    if (t = JSON.parse(u.readFileSync(o, "utf-8")), !Array.isArray(t.templateList)) {
      const i = `远程配置文件出错, templateList 不是数组, 请检查 ${w} ${n}.json`;
      throw new Error(i);
    }
    r.success("模板列表拉取成功！");
  } finally {
    u.rmSync(e, { recursive: !0, force: !0 });
  }
  return t;
}, J = async (e) => {
  const { projectName: t } = e, o = ((t ?? (await c(b)).projectName) || "").trim();
  if (!o)
    return r.error("项目名称不能为空"), process.exit(1);
  if (o.includes(" ") || o.includes("\\") || o.includes("/"))
    return r.error(`项目名称\`${o}\`不能包含空格或者\\或者/`), process.exit(1);
  const i = F(process.cwd(), o);
  if (v(i)) {
    const { isRemove: s } = await c(x());
    if (s === !0)
      f(i, { recursive: !0, force: !0 });
    else
      return r.error(`项目${o}已存在`), process.exit(1);
  }
  const { template: m } = await c(await U());
  let p = "", d = "";
  if (m === C) {
    const { customUrl: s } = await c(k);
    p = s;
  } else if (m === j)
    p = await O();
  else {
    const s = (await E()).find(
      (a) => a.name === m
    );
    if (!s)
      return r.error(`模板${m}不存在`), process.exit(1);
    if (!s.url)
      return r.error(`模板${m}仓库地址不存在`), process.exit(1);
    p = s.url, d = s.branch;
  }
  const N = G(".git");
  r.stage("正在初始化项目，请稍等..."), l(
    `git clone${d ? ` -b ${d}` : ""} ${p} ${o} --depth=1`,
    { stdio: "inherit" }
  );
  const h = L;
  if (R({
    rootDir: i,
    configPath: h
  }) && (await A({
    rootDir: i,
    configPath: h,
    extraEnvData: {
      $projectName: o
    }
  }), f(h, { force: !0 }), r.stage("模板项目配置注入成功, 模版项目配置文件已删除")), r.stage("项目初始化完成"), N) {
    const s = g.resolve(i), a = g.resolve(s, ".git");
    if (!v(a))
      throw new Error("git目录不存在");
    f(a, { recursive: !0, force: !0 }), r.stage(
      `项目创建在父级git仓库${N}中，已删除${o}目录下的.git(${a})`
    );
  } else if ((await c(H)).saveGitHistory)
    l("git remote rename origin upstream && git fetch --unshallow", {
      cwd: i,
      stdio: "inherit"
    }), r.stage(
      "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
    ), r.success("已保存git历史记录");
  else {
    const a = g.resolve(i, ".git");
    f(a, { recursive: !0, force: !0 }), l("git init", {
      cwd: i,
      stdio: "inherit"
    });
  }
  const { gitCommitMessage: _ } = await c(
    B(o)
  );
  l(`git add . && git commit -m '${_}'`, {
    cwd: i,
    stdio: "inherit"
  }), r.success(`项目${o}初始化完成`), r.info(`
使用步骤: 
  1. cd ${o}
  2. pnpm install
  3. pnpm run dev
  `);
}, {
  version: V,
  description: q,
  cliConfig: { moduleName: z }
} = y, T = {
  describe: q,
  version: V,
  positionals: {
    projectName: {
      describe: "项目名称",
      type: "string"
    }
  },
  handler: J
}, P = (e = !1) => {
  const t = `${e ? `${z} ` : ""}[projectName]`, n = `$0 ${t.trim()}`;
  return { command: t, usage: n };
}, re = async () => D({
  ...T,
  ...P()
}), oe = () => M({
  ...T,
  ...P(!0)
});
export {
  oe as a,
  re as c,
  J as h
};
